#ifndef __CBASIS_MARK_REGION_CONFIG_H__
#define __CBASIS_MARK_REGION_CONFIG_H__

// This is an overriding garbage collection policy flag
//#define MRC_NEVER_GARBAGE_COLLECT                   1

// This is an overriding implementation flag.
// This requires the flag MRC_NEVER_GARBAGE_COLLECT
// to be set as well, to avoid disasters
//#define MRC_ALLOCATE_WITH_MALLOC                    1

// When this is enabled, allocation pause times
// are measured. This currently makes everything
// run _very_ slowly compared to not timing allocations
//#define MRC_TIME_ALLOCATION_PAUSES                  1

// When this flag is defined, in-place generational GC is performed
#define MRC_ENABLE_IN_PLACE_GENERATIONAL            1

// When this flag is defined, in-place generational GC
// triggers partial collections based on how many
// bytes have been allocated since the last GC
#define MRC_IN_PLACE_GENERATIONAL_PARTIAL_WORK_BASED_BYTES 1

// When this flag is defined, incremental GC is enabled
// FIXME: This is buggy and incomplete
//#define MRC_ENABLE_INCREMENTAL                      1

// How long do we want an incremental garbage collect to run?
// FIXME: Lower values than 100ms seems to loop forever on ExlSharing22.sml,
//        but the idea is to get pause times down...
#define MRC_INCREMENTAL_TIMING_MICRO_SECONDS   100000

// Mark-region block-line size (currently not entirely configurable)
#define MRC_LINE_SIZE                             128

// Mark-region block size, 32 kilobytes (currently not entirely configurable)
#define MRC_BLOCK_SIZE                          32768

// Mark-region blocks to allocate at a time
#define MRC_BLOCKS_AT_A_TIME                       16


#endif // __CBASIS_MARK_REGION_CONFIG_H__
