#ifndef __CBASIS_MEM_STATS_H__
#define __CBASIS_MEM_STATS_H__

// This shows the operating system's view on memory usage (on Linux at least)
void BmsShowStats();

// Reset statistical information
void BmsResetStats();

// Functions for registering / gathering statistical information
void BmsRegisterAllocatedBytes(int bytes);
void BmsRegisterReclaimedBlock();
void BmsRegisterResetConservativeLive();
void BmsRegisterConservativeLiveBytes(int bytes);
void BmsRegisterCollectionComplete();
void BmsRegisterFullCollectionComplete();
void BmsRegisterPartialCollectionComplete();

// Functions for querying statistical information
int BmsGetConservativeLive();
int BmsGetPrevCollectionAllocBytes();
int BmsGetPartialPrevCollectionAllocBytes();
int BmsGetAllocBytes();

// Show gathered statistical information
void BmsShowStats();

#endif // __CBASIS_MEM_STATS_H__
