#include "CBasisPrim.h"
#include "CBasisMarkRegionConfig.h"
#include "CBasisImmixBlockPool.h"
#include "CBasisMemStats.h"
#include "CBasisTiming.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

/* Print a Pascal-style string, suitable for CeXL and Standard ML */
void ___print(char *str) {
    unsigned int len = *((unsigned int *)str);
    /* 100 characters should be enough to hold two unsigned integers */
    char format[100];
    /* ...but we still use snprintf, not taking any chances for overflow */
    snprintf(format, 99, "%%%d.%ds", (int)len, (int)len);
    printf(format, str + 4);
}

char *___String_append(char *str1, char *str2) {
    unsigned int len1 = *((unsigned int *)str1);
    unsigned int len2 = *((unsigned int *)str2);

    char *result = ___MemAlloc(len1 + len2 + 4);

    *((unsigned int *)result) = len1 + len2;
    memcpy(result + 4, str1 + 4, len1);
    memcpy(result + 4 + len1, str2 + 4, len2);
    return result;
}

int ___CharVector_dimensions(char *str) {
    return *((unsigned int *)str);
}

char *___CharVector_empty() {
    char *result = ___MemAlloc(4);

    *((unsigned int *)result) = 0;
    return result;
}

char *___CharVector_create(int length, int value) {
    char *result = ___MemAlloc(4 + length);

    *((unsigned int *)result) = length;
    memset(result + 4, (char)value, length);

    return result;
}

int ___CharVector_sub(char *str, int index) {
    unsigned int len = *((unsigned int *)str);
    if(index >= 0 && index < len) {
        return (int)(*(str+4+index));
    } else {
	puts("Index out of bounds in ___CharVector_sub");
        return 0;
    }
}

void ___CeXL_CharVector_update_(char *str, int index, int value) {
    unsigned int len = *((unsigned int *)str);
    if(index >= 0 && index < len) {
        *(str+4+index) = (char)value;
    } else {
        puts("Index out of bounds in ___CeXL_CharVector_update_");
    }
}

int ___Char_ord(int c) {
    // Well, this is trivial, since char is represented as 32-bit ints
    return c;
}

int ___Char_chr(int c) {
    // Well, this is trivial, since char is represented as 32-bit ints
    return c;
}

FILE **___TextIO_openOut(char *fileName) {
    FILE **file = malloc(sizeof(FILE *));
    *file = fopen(fileName, "w");

    return file;
}

void ___TextIO_closeOut(FILE **file) {
    fclose(*file);
    free(*file);
}

void ___TextIO_output(FILE **file, int len, void *data) {
    fwrite(data, 1, len, *file);
}

void *___MemAlloc(int size) {
#ifdef MRC_TIME_ALLOCATION_PAUSES
    BtiStartPauseTimer();
#endif
    BmsRegisterAllocatedBytes(size);
#ifdef MRC_ALLOCATE_WITH_MALLOC
    void *result = (void *)malloc(size);
#else
    void *result = (void *)IbpAlloc(size);
#endif
#ifdef MRC_TIME_ALLOCATION_PAUSES
    BtiReadPauseTimerMicro();
#endif
    return result;
}

void ___MemFree(void *addr) {
    free(addr);
}

// Clear all line marks, if initiating a full-heap liveness-trace
void ___MrClearLineMarks(unsigned int clearMask) {
    IbpClearLineMarkBitmapsInUse(clearMask);
}

// The function that garbage collection is all about
void ___MrReclaimGarbage() {
    IbpReclaimGarbage();
}

// Returns 1 if we should reclaim garbage, 0 otherwise
int ___MrShouldReclaimGarbage() {
    return IbpShouldReclaimGarbage();
}

// Return the tracing-function clear-mask for either a full
// or a partial heap collection, depending on what it is time for
unsigned int ___MrFullOrPartialClearMask() {
    return IbpFullOrPartialClearMask();
}

// Returns 1 if we should continue tracing back upwards the stack, 0 otherwise
int ___MrShouldStillTrace() {
#ifdef MRC_ENABLE_INCREMENTAL
    if(IbpShouldStillTrace()) {
	//printf("+");
        return 1;
    } else {
	//printf("-");
        return 0;
    }
    //return IbpShouldStillTrace();
#else
    return 1;
#endif
}
