#include "../CBasisImmixBlockPool.h"
#include "../CBasisMemStats.h"
#include <stdio.h>
#include <stdlib.h>

int main() {
    int *addr;
    int *mem[1000];
    int size = 4;
    int cnt;
    
    for(cnt = 0; cnt < 1000; cnt++) {
        mem[cnt] = IbpAlloc(size);
        *(mem[cnt]) = size;
	size += 4;
        printf("%d, ", (int)(mem[cnt]));
    }
    puts("");

    size = 4;
    for(cnt = 0; cnt < 1000; cnt++) {
	if(size != *(mem[cnt])) {
	    printf("Expecting size %d to be stored, but found size %d\n",
		   (int)size, (int)(*(mem[cnt])));
            exit(-1);
	}
	size += 4;
    }

    puts("Successful allocation");
    BmsShowStats();

    // Write at a few select memory addresses
    addr = ((mem[30]) + 20);
    *addr = 42;
    IbpLineMarkAddr(addr);
    addr = ((mem[40]) + 24);
    *addr = 50;
    IbpLineMarkAddr(addr);
    addr = ((mem[50]) + 28);
    *addr = 58;
    IbpLineMarkAddr(addr);

    // Reclaim memory
    IbpReclaimGarbage();

    BmsShowStats();

    for(cnt = 0; cnt < 32000; cnt++) {
        addr = IbpAlloc(4);
        *addr = 0;
    }

    // Verify that the memory addresses are retained
    if(*((mem[30]) + 20) != 42) {
	puts("Expecting value 42 to be retained in memory");
        exit(-1);
    }
    if(*((mem[40]) + 24) != 50) {
	puts("Expecting value 50 to be retained in memory");
        exit(-1);
    }
    if(*((mem[50]) + 28) != 58) {
	puts("Expecting value 58 to be retained in memory");
        exit(-1);
    }

    BmsShowStats();

    // Reclaim memory
    IbpReclaimGarbage();

    puts("Success");
    BmsShowStats();

    exit(0);
}
